︠5a0de266-487a-4191-9bce-085a33e7ccd4s︠
# based on code from oddrobot, http://sagenb.org/home/pub/1532/
from sage.calculus.desolvers import desolve_system_rk4
x,y,t=var('x y t')
class DESolution:
    def __init__(self,system,time_range,initial,stepsize=0.05,initial_points=20):
        self.tvar=time_range[0]
        self._times=srange(time_range[1],time_range[2],stepsize)
        self.vars=[v for v,_ in initial]
        self.dim=len(self.vars)
        self._system=system
        # check to see if we need one solution or multiple solutions
        if isinstance(initial[0][1],(list,tuple)):
            # multiple initial values, from the first value of each variable to the last value of each variable
            start = vector([a for _,(a,b) in initial])
            line = vector([b for _,(a,b) in initial])-start
            self._soln = [desolve_odeint(system, ics=list(start+t*line),
                              times=self._times, dvars=self.vars, ivar=self.tvar) for t in srange(0,1,step=1/(initial_points-1),include_endpoint=True)]
        else:
            self._soln = [desolve_odeint(system, ics=[v for _,v in initial],times=self._times, dvars=self.vars, ivar=self.tvar)]

    def phase_plot(self,vars=None,color='blue',**kwargs):
        # find which indices the specified variables are
        if vars is not None:
            vars_index=[self.vars.index(v) for v in vars]
        elif self.dim<=3:
            vars_index=range(self.dim)
        else:
            vars_index=range(2)
        p = Graphics()
        for s in self._soln:
            p+=line(s[:,vars_index],color=color,**kwargs)
            # add an arrow head showing which way we are going around the phase line
            half=int(s.shape[0]/2)
            p+=arrow(s[half,vars_index], s[half+1,vars_index],color='red')
        if len(vars_index)==2:
            p.axes_labels([str(self.vars[v]) for v in vars_index])
        return p

    def coordinates(self,colors=None,**kwargs):
        if colors is None:
            colors=rainbow(len(self.vars))
        p=Graphics()
        legend=True
        for s in self._soln:
            # only want legends the first time
            p+=sum(line(zip(self._times,s[:,i]), color=colors[i], legend_label=str(self.vars[i]) if legend else None,**kwargs) for i in range(self.dim))
            legend=False
        return p


#ADA 14 Equipo 2.
var('x,y,z')
A = matrix([[0,-5,0],[5,0,0],[0,0,-2]])
show(A)
R = matrix([[1/2,-1/sqrt(2),1/2],[1/2,1/sqrt(2),1/2],[-1/sqrt(2),0,1/sqrt(2)]])
#R es la matriz de rotación que es composición de una rotación de -45° en el plano xz seguida de una rotación de 45° en el plano xy.
show(R)
show(R^-1)
M=R*A*(R^-1)
a=matrix([[2],[2],[-5]])
show(R*a)
b=matrix([[-1],[4],[5]])
show(R*b)
show(M)
show(M.eigenvectors_right())
show(M.characteristic_polynomial())
show(M.characteristic_polynomial().roots())
show(M.eigenvalues())
F=[-(1/2)*x-(1/2)*(5*sqrt(2)+1)*y+(1/2)*(5-sqrt(2))*z,(1/2)*(5*sqrt(2)-1)*x-(1/2)*y-(1/2)*(sqrt(2)+5)*z,-(1/2)*(sqrt(2)+5)*x+(1/2)*(5-sqrt(2))*y-z]
solution=DESolution(F,[t,0,15],[[x,(-sqrt(2)-3/2,-2*sqrt(2)+2)],(y,[sqrt(2)-3/2,2*sqrt(2)+2]),[z,[-7/sqrt(2),3*sqrt(2)]]])
solution.coordinates(['red','blue','green'])
solution.phase_plot()

︡8b99dfb5-bcb0-40c6-aa4f-661decbf3f18︡{"stdout":"(x, y, z)\n"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n0 &amp; -5 &amp; 0 \\\\\n5 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; -2\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n\\frac{1}{2} &amp; -\\frac{1}{2} \\, \\sqrt{2} &amp; \\frac{1}{2} \\\\\n\\frac{1}{2} &amp; \\frac{1}{2} \\, \\sqrt{2} &amp; \\frac{1}{2} \\\\\n-\\frac{1}{2} \\, \\sqrt{2} &amp; 0 &amp; \\frac{1}{2} \\, \\sqrt{2}\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n\\frac{1}{2} &amp; \\frac{1}{2} &amp; -\\frac{1}{2} \\, \\sqrt{2} \\\\\n-\\frac{1}{2} \\, \\sqrt{2} &amp; \\frac{1}{2} \\, \\sqrt{2} &amp; 0 \\\\\n\\frac{1}{2} &amp; \\frac{1}{2} &amp; \\frac{1}{2} \\, \\sqrt{2}\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{r}\n-\\sqrt{2} - \\frac{3}{2} \\\\\n\\sqrt{2} - \\frac{3}{2} \\\\\n-\\frac{7}{2} \\, \\sqrt{2}\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{r}\n-2 \\, \\sqrt{2} + 2 \\\\\n2 \\, \\sqrt{2} + 2 \\\\\n3 \\, \\sqrt{2}\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n-\\frac{1}{2} &amp; -\\frac{5}{2} \\, \\sqrt{2} - \\frac{1}{2} &amp; -\\frac{1}{2} \\, \\sqrt{2} + \\frac{5}{2} \\\\\n\\frac{5}{2} \\, \\sqrt{2} - \\frac{1}{2} &amp; -\\frac{1}{2} &amp; -\\frac{1}{2} \\, \\sqrt{2} - \\frac{5}{2} \\\\\n-\\frac{1}{2} \\, \\sqrt{2} - \\frac{5}{2} &amp; -\\frac{1}{2} \\, \\sqrt{2} + \\frac{5}{2} &amp; -1\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>[($\\displaystyle -5 i$, [$\\displaystyle \\left(1,\\,\\frac{2}{3} i \\, \\sqrt{2} - \\frac{1}{3},\\,-\\frac{1}{3} \\, \\sqrt{2} - \\frac{2}{3} i\\right)$], $\\displaystyle 1$), ($\\displaystyle 5 i$, [$\\displaystyle \\left(1,\\,-\\frac{2}{3} i \\, \\sqrt{2} - \\frac{1}{3},\\,-\\frac{1}{3} \\, \\sqrt{2} + \\frac{2}{3} i\\right)$], $\\displaystyle 1$), ($\\displaystyle -2$, [$\\displaystyle \\left(1,\\,1,\\,\\sqrt{2}\\right)$], $\\displaystyle 1$)]</div>"}︡{"html":"<div align='center'>$\\displaystyle x^{3} + 2 x^{2} + 25 x + 50$</div>"}︡{"html":"<div align='center'>[($\\displaystyle -5 i$, $\\displaystyle 1$), ($\\displaystyle 5 i$, $\\displaystyle 1$), ($\\displaystyle -2$, $\\displaystyle 1$)]</div>"}︡{"html":"<div align='center'>[$\\displaystyle -5 i$, $\\displaystyle 5 i$, $\\displaystyle -2$]</div>"}︡{"file":{"filename":"/home/user/.sage/temp/project-56cc8ce6-3e7d-446f-b6f1-13760ee8a615/570/tmp_uitmhc1p.svg","show":true,"text":null,"uuid":"5c1cf4b0-ad26-487f-a80b-8c88406f1c9c"},"once":false}︡{"file":{"filename":"e5a176f5-7605-4410-b7b1-441ed0502020.sage3d","uuid":"e5a176f5-7605-4410-b7b1-441ed0502020"}}︡{"done":true}
︠c0444dc2-d7f5-4e69-90cb-22f3b1221df1s︠
x,y,z=var('x,y,z')

# Next we define the parameters
sigma=10
rho=28
beta=8/3

# The Lorenz equations
lorenz=[sigma*(y-x),x*(rho-z)-y,x*y-beta*z]

# Time and initial conditions
N=250000
tmax=250
h=tmax/N
t=srange(0,tmax+h,h)
ics=[0,1,1]
sol=desolve_odeint(lorenz,ics,t,[x,y,z],rtol=1e-13,atol=1e-14)
X=sol[:,0]
Y=sol[:,1]
Z=sol[:,2]
# Plot the result
from mpl_toolkits.mplot3d import axes3d
from matplotlib import pyplot as plt
# Call the plot function if you want to plot the data
def plot():
    fig = plt.figure(1)
    ax = fig.add_subplot(111, projection='3d')
#   ax.plot_wireframe(X, Y, Z, rstride=10, cstride=10)
    ax.plot(X, Y, Z)
    ax.set_xlabel('X(t)')
    ax.set_ylabel('Y(t)')
    ax.set_zlabel('Z(t)')
    plt.show()

plot()
︡86be3d51-4cea-4533-80d1-aa3ae13cdc9f︡{"file":{"filename":"c96ab032-f258-4102-b557-a0666670d617.svg","show":true,"text":null,"uuid":"34ee967b-c266-4cf3-81a0-a8d76309fb78"},"once":false}︡{"done":true}
︠d53bc76f-6ec6-44e5-a75f-389ed23d00c6s︠
var('a,x,y,z,w')
initial=[[x,[y,1]],[y,[z,2]],[z,[w,3]]]
p=[[x,y,z],[1,2,3]]
[v for v,_ in initial]
[a for _,(a,b) in initial]
[b for _,[_,b] in initial]
[c for _,c,_ in p]
initial[0][1]
︡b4d769fa-0175-4b47-bdf1-981f344f0a73︡{"stdout":"(a, x, y, z, w)\n"}︡{"stdout":"[x, y, z]\n"}︡{"stdout":"[y, z, w]\n"}︡{"stdout":"[1, 2, 3]\n"}︡{"stdout":"[y, 2]\n"}︡{"stdout":"[y, 1]\n"}︡{"done":true}︡
︠86592671-7205-4785-854d-c462225fbbcas︠
from sage.calculus.desolvers import desolve_odeint
from sage.manifolds.utilities import set_axes_labels
x,y,z=var('x,y,z')
f=[x*(1-y),-y*(1-x),-z]
sol=desolve_odeint(f,[0.5,2,1],srange(0,10,0.1),[x,y,z])
p=Graphics()
p=line3d(zip(sol[:,0],sol[:,1],sol[:,2]))
ga = set_axes_labels(p, 'X', 'Y', 'Z', color='red')
#print(ga)
show(ga)  # the 3D frame has now axes labels
p.show()
︡c0ca3d15-4f15-4d41-83a6-8979064abf17︡{"file":{"filename":"cf8418bf-bd3b-4c56-b038-fa61960b0485.sage3d","uuid":"cf8418bf-bd3b-4c56-b038-fa61960b0485"}}︡{"file":{"filename":"195060fc-f463-41f7-8b19-57c37fdad5ab.sage3d","uuid":"195060fc-f463-41f7-8b19-57c37fdad5ab"}}︡{"done":true}









